/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.174 Revision 1.400
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.174 2005/05/24 05:10:19 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.400 2012/06/20 09:26:50 mgorny Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6#
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 4
12inherit multilib 5# @ECLASS: eutils.eclass
13ECLASS=eutils 6# @MAINTAINER:
14INHERITED="$INHERITED $ECLASS" 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
15 17
16DEPEND="!bootstrap? ( sys-devel/patch )" 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
20
21inherit multilib toolchain-funcs user
17 22
18DESCRIPTION="Based on the ${ECLASS} eclass" 23DESCRIPTION="Based on the ${ECLASS} eclass"
19 24
20# Wait for the supplied number of seconds. If no argument is supplied, defaults 25if has "${EAPI:-0}" 0 1 2; then
21# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 26
22# outputting to a terminal, don't wait. For compatability purposes, the argument 27# @FUNCTION: epause
23# must be an integer greater than zero. 28# @USAGE: [seconds]
24# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 29# @DESCRIPTION:
30# Sleep for the specified number of seconds (default of 5 seconds). Useful when
31# printing a message the user should probably be reading and often used in
32# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
33# don't wait at all. Defined in EAPIs 0 1 and 2.
25epause() { 34epause() {
26 if [ -z "$EPAUSE_IGNORE" ] && [ -t 1 ] ; then 35 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
27 sleep ${1:-5}
28 fi
29} 36}
30 37
31# Beep the specified number of times (defaults to five). If our output 38# @FUNCTION: ebeep
32# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 39# @USAGE: [number of beeps]
33# don't beep. 40# @DESCRIPTION:
34# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 41# Issue the specified number of beeps (default of 5 beeps). Useful when
42# printing a message the user should probably be reading and often used in
43# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
44# don't beep at all. Defined in EAPIs 0 1 and 2.
35ebeep() { 45ebeep() {
36 local n 46 local n
37 if [ -z "$EBEEP_IGNORE" ] && [ -t 1 ] ; then 47 if [[ -z ${EBEEP_IGNORE} ]] ; then
38 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 48 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
39 echo -ne "\a" 49 echo -ne "\a"
40 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null 50 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
41 echo -ne "\a" 51 echo -ne "\a"
42 sleep 1 52 sleep 1
43 done 53 done
44 fi 54 fi
45} 55}
46 56
47# This function generate linker scripts in /usr/lib for dynamic 57else
48# libs in /lib. This is to fix linking problems when you have
49# the .so in /lib, and the .a in /usr/lib. What happens is that
50# in some cases when linking dynamic, the .a in /usr/lib is used
51# instead of the .so in /lib due to gcc/libtool tweaking ld's
52# library search path. This cause many builds to fail.
53# See bug #4411 for more info.
54#
55# To use, simply call:
56#
57# gen_usr_ldscript libfoo.so
58#
59# Note that you should in general use the unversioned name of
60# the library, as ldconfig should usually update it correctly
61# to point to the latest version of the library present.
62#
63# <azarah@gentoo.org> (26 Oct 2002)
64#
65gen_usr_ldscript() {
66 local libdir="$(get_libdir)"
67 # Just make sure it exists
68 dodir /usr/${libdir}
69 58
70 for lib in "${@}" ; do 59ebeep() {
71 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 60 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
72 /* GNU ld script 61}
73 Since Gentoo has critical dynamic libraries 62
74 in /lib, and the static versions in /usr/lib, 63epause() {
75 we need to have a "fake" dynamic lib in /usr/lib, 64 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
76 otherwise we run into linking problems. 65}
66
67fi
68
69# @FUNCTION: eqawarn
70# @USAGE: [message]
71# @DESCRIPTION:
72# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
73# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
74# profile.
75if ! declare -F eqawarn >/dev/null ; then
76 eqawarn() {
77 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
77 78 :
78 See bug http://bugs.gentoo.org/4411 for more info. 79 }
79 */ 80fi
80 GROUP ( /${libdir}/${lib} ) 81
81 END_LDSCRIPT 82# @FUNCTION: ecvs_clean
82 fperms a+x "/usr/${libdir}/${lib}" 83# @USAGE: [list of dirs]
84# @DESCRIPTION:
85# Remove CVS directories recursiveley. Useful when a source tarball contains
86# internal CVS directories. Defaults to $PWD.
87ecvs_clean() {
88 [[ -z $* ]] && set -- .
89 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
90 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
91}
92
93# @FUNCTION: esvn_clean
94# @USAGE: [list of dirs]
95# @DESCRIPTION:
96# Remove .svn directories recursiveley. Useful when a source tarball contains
97# internal Subversion directories. Defaults to $PWD.
98esvn_clean() {
99 [[ -z $* ]] && set -- .
100 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
101}
102
103# @FUNCTION: estack_push
104# @USAGE: <stack> [items to push]
105# @DESCRIPTION:
106# Push any number of items onto the specified stack. Pick a name that
107# is a valid variable (i.e. stick to alphanumerics), and push as many
108# items as you like onto the stack at once.
109#
110# The following code snippet will echo 5, then 4, then 3, then ...
111# @CODE
112# estack_push mystack 1 2 3 4 5
113# while estack_pop mystack i ; do
114# echo "${i}"
83 done 115# done
116# @CODE
117estack_push() {
118 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
119 local stack_name="__ESTACK_$1__" ; shift
120 eval ${stack_name}+=\( \"\$@\" \)
84} 121}
85 122
86# Simple function to draw a line consisting of '=' the same length as $* 123# @FUNCTION: estack_pop
87# - only to be used by epatch() 124# @USAGE: <stack> [variable]
88# 125# @DESCRIPTION:
89# <azarah@gentoo.org> (11 Nov 2002) 126# Pop a single item off the specified stack. If a variable is specified,
90# 127# the popped item is stored there. If no more items are available, return
91draw_line() { 128# 1, else return 0. See estack_push for more info.
92 local i=0 129estack_pop() {
93 local str_length="" 130 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
94 131
95 # Handle calls that do not have args, or wc not being installed ... 132 # We use the fugly __estack_xxx var names to avoid collision with
96 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ] 133 # passing back the return value. If we used "local i" and the
97 then 134 # caller ran `estack_pop ... i`, we'd end up setting the local
98 echo "===============================================================" 135 # copy of "i" rather than the caller's copy. The __estack_xxx
136 # garbage is preferable to using $1/$2 everywhere as that is a
137 # bit harder to read.
138 local __estack_name="__ESTACK_$1__" ; shift
139 local __estack_retvar=$1 ; shift
140 eval local __estack_i=\${#${__estack_name}\[@\]}
141 # Don't warn -- let the caller interpret this as a failure
142 # or as normal behavior (akin to `shift`)
143 [[ $(( --__estack_i )) -eq -1 ]] && return 1
144
145 if [[ -n ${__estack_retvar} ]] ; then
146 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
147 fi
148 eval unset ${__estack_name}\[${__estack_i}\]
149}
150
151# @FUNCTION: eshopts_push
152# @USAGE: [options to `set` or `shopt`]
153# @DESCRIPTION:
154# Often times code will want to enable a shell option to change code behavior.
155# Since changing shell options can easily break other pieces of code (which
156# assume the default state), eshopts_push is used to (1) push the current shell
157# options onto a stack and (2) pass the specified arguments to set.
158#
159# If the first argument is '-s' or '-u', we assume you want to call `shopt`
160# rather than `set` as there are some options only available via that.
161#
162# A common example is to disable shell globbing so that special meaning/care
163# may be used with variables/arguments to custom functions. That would be:
164# @CODE
165# eshopts_push -s noglob
166# for x in ${foo} ; do
167# if ...some check... ; then
168# eshopts_pop
99 return 0 169# return 0
100 fi 170# fi
101
102 # Get the length of $*
103 str_length="$(echo -n "$*" | wc -m)"
104
105 while [ "$i" -lt "${str_length}" ]
106 do
107 echo -n "="
108
109 i=$((i + 1))
110 done 171# done
111 172# eshopts_pop
112 echo 173# @CODE
113 174eshopts_push() {
114 return 0 175 if [[ $1 == -[su] ]] ; then
176 estack_push eshopts "$(shopt -p)"
177 [[ $# -eq 0 ]] && return 0
178 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
179 else
180 estack_push eshopts $-
181 [[ $# -eq 0 ]] && return 0
182 set "$@" || die "${FUNCNAME}: bad options to set: $*"
183 fi
115} 184}
116 185
117# Default directory where patches are located 186# @FUNCTION: eshopts_pop
187# @USAGE:
188# @DESCRIPTION:
189# Restore the shell options to the state saved with the corresponding
190# eshopts_push call. See that function for more details.
191eshopts_pop() {
192 local s
193 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
194 if [[ ${s} == "shopt -"* ]] ; then
195 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
196 else
197 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
198 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
199 fi
200}
201
202# @FUNCTION: eumask_push
203# @USAGE: <new umask>
204# @DESCRIPTION:
205# Set the umask to the new value specified while saving the previous
206# value onto a stack. Useful for temporarily changing the umask.
207eumask_push() {
208 estack_push eumask "$(umask)"
209 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
210}
211
212# @FUNCTION: eumask_pop
213# @USAGE:
214# @DESCRIPTION:
215# Restore the previous umask state.
216eumask_pop() {
217 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
218 local s
219 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
220 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
221}
222
223# @VARIABLE: EPATCH_SOURCE
224# @DESCRIPTION:
225# Default directory to search for patches.
118EPATCH_SOURCE="${WORKDIR}/patch" 226EPATCH_SOURCE="${WORKDIR}/patch"
119# Default extension for patches 227# @VARIABLE: EPATCH_SUFFIX
228# @DESCRIPTION:
229# Default extension for patches (do not prefix the period yourself).
120EPATCH_SUFFIX="patch.bz2" 230EPATCH_SUFFIX="patch.bz2"
121# Default options for patch 231# @VARIABLE: EPATCH_OPTS
232# @DESCRIPTION:
233# Options to pass to patch. Meant for ebuild/package-specific tweaking
234# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
235# for single patch tweaking, you can also pass flags directly to epatch.
236EPATCH_OPTS=""
237# @VARIABLE: EPATCH_COMMON_OPTS
238# @DESCRIPTION:
239# Common options to pass to `patch`. You probably should never need to
240# change these. If you do, please discuss it with base-system first to
241# be sure.
242# @CODE
122# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 243# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
123# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 244# --no-backup-if-mismatch - do not leave .orig files behind
245# -E - automatically remove empty files
246# @CODE
124EPATCH_OPTS="-g0 --no-backup-if-mismatch" 247EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
248# @VARIABLE: EPATCH_EXCLUDE
249# @DESCRIPTION:
125# List of patches not to apply. Not this is only file names, 250# List of patches not to apply. Note this is only file names,
126# and not the full path .. 251# and not the full path. Globs accepted.
127EPATCH_EXCLUDE="" 252EPATCH_EXCLUDE=""
253# @VARIABLE: EPATCH_SINGLE_MSG
254# @DESCRIPTION:
128# Change the printed message for a single patch. 255# Change the printed message for a single patch.
129EPATCH_SINGLE_MSG="" 256EPATCH_SINGLE_MSG=""
257# @VARIABLE: EPATCH_MULTI_MSG
258# @DESCRIPTION:
130# Change the printed message for multiple patches. 259# Change the printed message for multiple patches.
131EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 260EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
132# Force applying bulk patches even if not following the style: 261# @VARIABLE: EPATCH_FORCE
133# 262# @DESCRIPTION:
134# ??_${ARCH}_foo.${EPATCH_SUFFIX} 263# Only require patches to match EPATCH_SUFFIX rather than the extended
135# 264# arch naming style.
136EPATCH_FORCE="no" 265EPATCH_FORCE="no"
137 266
138# This function is for bulk patching, or in theory for just one 267# @FUNCTION: epatch
139# or two patches. 268# @USAGE: [options] [patches] [dirs of patches]
269# @DESCRIPTION:
270# epatch is designed to greatly simplify the application of patches. It can
271# process patch files directly, or directories of patches. The patches may be
272# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
273# the -p option as epatch will automatically attempt -p0 to -p5 until things
274# apply successfully.
140# 275#
141# It should work with .bz2, .gz, .zip and plain text patches. 276# If you do not specify any patches/dirs, then epatch will default to the
142# Currently all patches should be the same format. 277# directory specified by EPATCH_SOURCE.
143# 278#
144# You do not have to specify '-p' option to patch, as it will 279# Any options specified that start with a dash will be passed down to patch
145# try with -p0 to -p5 until it succeed, or fail at -p5. 280# for this specific invocation. As soon as an arg w/out a dash is found, then
281# arg processing stops.
146# 282#
147# Above EPATCH_* variables can be used to control various defaults, 283# When processing directories, epatch will apply all patches that match:
148# bug they should be left as is to ensure an ebuild can rely on 284# @CODE
149# them for. 285# if ${EPATCH_FORCE} != "yes"
150#
151# Patches are applied in current directory.
152#
153# Bulk Patches should preferibly have the form of:
154#
155# ??_${ARCH}_foo.${EPATCH_SUFFIX} 286# ??_${ARCH}_foo.${EPATCH_SUFFIX}
287# else
288# *.${EPATCH_SUFFIX}
289# @CODE
290# The leading ?? are typically numbers used to force consistent patch ordering.
291# The arch field is used to apply patches only for the host architecture with
292# the special value of "all" means apply for everyone. Note that using values
293# other than "all" is highly discouraged -- you should apply patches all the
294# time and let architecture details be detected at configure/compile time.
156# 295#
157# For example: 296# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
297# for patches to apply.
158# 298#
159# 01_all_misc-fix.patch.bz2 299# Refer to the other EPATCH_xxx variables for more customization of behavior.
160# 02_sparc_another-fix.patch.bz2
161#
162# This ensures that there are a set order, and you can have ARCH
163# specific patches.
164#
165# If you however give an argument to epatch(), it will treat it as a
166# single patch that need to be applied if its a file. If on the other
167# hand its a directory, it will set EPATCH_SOURCE to this.
168#
169# <azarah@gentoo.org> (10 Nov 2002)
170#
171epatch() { 300epatch() {
172 local PIPE_CMD="" 301 _epatch_draw_line() {
173 local STDERR_TARGET="${T}/$$.out" 302 # create a line of same length as input string
174 local PATCH_TARGET="${T}/$$.patch" 303 [[ -z $1 ]] && set "$(printf "%65s" '')"
175 local PATCH_SUFFIX="" 304 echo "${1//?/=}"
176 local SINGLE_PATCH="no" 305 }
177 local x=""
178 306
179 if [ "$#" -gt 1 ] 307 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
180 then 308
309 # First process options. We localize the EPATCH_OPTS setting
310 # from above so that we can pass it on in the loop below with
311 # any additional values the user has specified.
312 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
313 while [[ $# -gt 0 ]] ; do
314 case $1 in
315 -*) EPATCH_OPTS+=( "$1" ) ;;
316 *) break ;;
317 esac
318 shift
319 done
320
321 # Let the rest of the code process one user arg at a time --
322 # each arg may expand into multiple patches, and each arg may
323 # need to start off with the default global EPATCH_xxx values
324 if [[ $# -gt 1 ]] ; then
181 local m="" 325 local m
182 for m in "$@" ; do 326 for m in "$@" ; do
183 epatch "${m}" 327 epatch "${m}"
184 done 328 done
185 return 0 329 return 0
186 fi 330 fi
187 331
188 if [ -n "$1" -a -f "$1" ] 332 local SINGLE_PATCH="no"
189 then 333 # no args means process ${EPATCH_SOURCE}
334 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
335
336 if [[ -f $1 ]] ; then
190 SINGLE_PATCH="yes" 337 SINGLE_PATCH="yes"
191 338 set -- "$1"
192 local EPATCH_SOURCE="$1" 339 # Use the suffix from the single patch (localize it); the code
340 # below will find the suffix for us
193 local EPATCH_SUFFIX="${1##*\.}" 341 local EPATCH_SUFFIX=$1
194 342
195 elif [ -n "$1" -a -d "$1" ] 343 elif [[ -d $1 ]] ; then
196 then 344 # Some people like to make dirs of patches w/out suffixes (vim)
197 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 345 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
198 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 346
347 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
348 # Re-use EPATCH_SOURCE as a search dir
349 epatch "${EPATCH_SOURCE}/$1"
350 return $?
351
352 else
353 # sanity check ... if it isn't a dir or file, wtf man ?
354 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
355 echo
356 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
357 eerror
358 eerror " ${EPATCH_SOURCE}"
359 eerror " ( ${EPATCH_SOURCE##*/} )"
360 echo
361 die "Cannot find \$EPATCH_SOURCE!"
362 fi
363
364 # Now that we know we're actually going to apply something, merge
365 # all of the patch options back in to a single variable for below.
366 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
367
368 local PIPE_CMD
369 case ${EPATCH_SUFFIX##*\.} in
370 xz) PIPE_CMD="xz -dc" ;;
371 lzma) PIPE_CMD="lzma -dc" ;;
372 bz2) PIPE_CMD="bzip2 -dc" ;;
373 gz|Z|z) PIPE_CMD="gzip -dc" ;;
374 ZIP|zip) PIPE_CMD="unzip -p" ;;
375 *) ;;
376 esac
377
378 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
379
380 local x
381 for x in "$@" ; do
382 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
383 # didn't match anything, ignore continue on
384 [[ ! -f ${x} ]] && continue
385
386 local patchname=${x##*/}
387
388 # Apply single patches, or forced sets of patches, or
389 # patches with ARCH dependant names.
390 # ???_arch_foo.patch
391 # Else, skip this input altogether
392 local a=${patchname#*_} # strip the ???_
393 a=${a%%_*} # strip the _foo.patch
394 if ! [[ ${SINGLE_PATCH} == "yes" || \
395 ${EPATCH_FORCE} == "yes" || \
396 ${a} == all || \
397 ${a} == ${ARCH} ]]
199 then 398 then
200 local EPATCH_SOURCE="$1/*" 399 continue
400 fi
401
402 # Let people filter things dynamically
403 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
404 # let people use globs in the exclude
405 eshopts_push -o noglob
406
407 local ex
408 for ex in ${EPATCH_EXCLUDE} ; do
409 if [[ ${patchname} == ${ex} ]] ; then
410 eshopts_pop
411 continue 2
412 fi
413 done
414
415 eshopts_pop
416 fi
417
418 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
419 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
420 einfo "${EPATCH_SINGLE_MSG}"
421 else
422 einfo "Applying ${patchname} ..."
423 fi
201 else 424 else
202 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 425 einfo " ${patchname} ..."
203 fi 426 fi
204 else 427
205 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 428 # most of the time, there will only be one run per unique name,
206 then 429 # but if there are more, make sure we get unique log filenames
207 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 430 local STDERR_TARGET="${T}/${patchname}.out"
208 then 431 if [[ -e ${STDERR_TARGET} ]] ; then
209 EPATCH_SOURCE="$1" 432 STDERR_TARGET="${T}/${patchname}-$$.out"
433 fi
434
435 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
436
437 # Decompress the patch if need be
438 local count=0
439 local PATCH_TARGET
440 if [[ -n ${PIPE_CMD} ]] ; then
441 PATCH_TARGET="${T}/$$.patch"
442 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
443
444 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
445 echo
446 eerror "Could not extract patch!"
447 #die "Could not extract patch!"
448 count=5
449 break
210 fi 450 fi
451 else
452 PATCH_TARGET=${x}
453 fi
211 454
455 # Check for absolute paths in patches. If sandbox is disabled,
456 # people could (accidently) patch files in the root filesystem.
457 # Or trigger other unpleasantries #237667. So disallow -p0 on
458 # such patches.
459 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
460 if [[ -n ${abs_paths} ]] ; then
461 count=1
462 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
463 fi
464 # Similar reason, but with relative paths.
465 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
466 if [[ -n ${rel_paths} ]] ; then
467 eqawarn "QA Notice: Your patch uses relative paths '../'."
468 eqawarn " In the future this will cause a failure."
469 eqawarn "${rel_paths}"
470 fi
471
472 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
473 local patch_cmd
474 while [[ ${count} -lt 5 ]] ; do
475 patch_cmd="${BASH_ALIASES[patch]:-patch} -p${count} ${EPATCH_OPTS}"
476
477 # Generate some useful debug info ...
478 (
479 _epatch_draw_line "***** ${patchname} *****"
212 echo 480 echo
213 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 481 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
482 echo
483 _epatch_draw_line "***** ${patchname} *****"
484 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
485 ret=$?
486 echo
487 echo "patch program exited with status ${ret}"
488 exit ${ret}
489 ) >> "${STDERR_TARGET}"
490
491 if [ $? -eq 0 ] ; then
492 (
493 _epatch_draw_line "***** ${patchname} *****"
494 echo
495 echo "ACTUALLY APPLYING ${patchname} ..."
496 echo
497 _epatch_draw_line "***** ${patchname} *****"
498 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
499 ret=$?
500 echo
501 echo "patch program exited with status ${ret}"
502 exit ${ret}
503 ) >> "${STDERR_TARGET}"
504
505 if [ $? -ne 0 ] ; then
506 echo
507 eerror "A dry-run of patch command succeeded, but actually"
508 eerror "applying the patch failed!"
509 #die "Real world sux compared to the dreamworld!"
510 count=5
511 fi
512 break
513 fi
514
515 : $(( count++ ))
516 done
517
518 # if we had to decompress the patch, delete the temp one
519 if [[ -n ${PIPE_CMD} ]] ; then
520 rm -f "${PATCH_TARGET}"
521 fi
522
523 if [[ ${count} -ge 5 ]] ; then
524 echo
525 eerror "Failed Patch: ${patchname} !"
526 eerror " ( ${PATCH_TARGET} )"
214 eerror 527 eerror
215 eerror " ${EPATCH_SOURCE}" 528 eerror "Include in your bugreport the contents of:"
216 eerror " ( ${EPATCH_SOURCE##*/} )" 529 eerror
530 eerror " ${STDERR_TARGET}"
217 echo 531 echo
218 die "Cannot find \$EPATCH_SOURCE!"
219 fi
220
221 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
222 fi
223
224 case ${EPATCH_SUFFIX##*\.} in
225 bz2)
226 PIPE_CMD="bzip2 -dc"
227 PATCH_SUFFIX="bz2"
228 ;;
229 gz|Z|z)
230 PIPE_CMD="gzip -dc"
231 PATCH_SUFFIX="gz"
232 ;;
233 ZIP|zip)
234 PIPE_CMD="unzip -p"
235 PATCH_SUFFIX="zip"
236 ;;
237 *)
238 PIPE_CMD="cat"
239 PATCH_SUFFIX="patch"
240 ;;
241 esac
242
243 if [ "${SINGLE_PATCH}" = "no" ]
244 then
245 einfo "${EPATCH_MULTI_MSG}"
246 fi
247 for x in ${EPATCH_SOURCE}
248 do
249 # New ARCH dependant patch naming scheme ...
250 #
251 # ???_arch_foo.patch
252 #
253 if [ -f ${x} ] && \
254 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ] || \
255 [ "${EPATCH_FORCE}" = "yes" ])
256 then
257 local count=0
258 local popts="${EPATCH_OPTS}"
259 local patchname=${x##*/}
260
261 if [ -n "${EPATCH_EXCLUDE}" ]
262 then
263 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
264 then
265 continue
266 fi
267 fi
268
269 if [ "${SINGLE_PATCH}" = "yes" ]
270 then
271 if [ -n "${EPATCH_SINGLE_MSG}" ]
272 then
273 einfo "${EPATCH_SINGLE_MSG}"
274 else
275 einfo "Applying ${patchname} ..."
276 fi
277 else
278 einfo " ${patchname} ..."
279 fi
280
281 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
282 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
283
284 # Allow for prefix to differ ... im lazy, so shoot me :/
285 while [ "${count}" -lt 5 ]
286 do
287 # Generate some useful debug info ...
288 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
289 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
290
291 if [ "${PATCH_SUFFIX}" != "patch" ]
292 then
293 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
294 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
295 else
296 PATCH_TARGET="${x}"
297 fi
298
299 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
300 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
301
302 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
303 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
304
305 if [ "${PATCH_SUFFIX}" != "patch" ]
306 then
307 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
308 then
309 echo
310 eerror "Could not extract patch!"
311 #die "Could not extract patch!"
312 count=5
313 break
314 fi
315 fi
316
317 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
318 then
319 draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
320 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
321 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
322 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
323 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
324
325 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
326
327 if [ "$?" -ne 0 ]
328 then
329 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
330 echo
331 eerror "A dry-run of patch command succeeded, but actually"
332 eerror "applying the patch failed!"
333 #die "Real world sux compared to the dreamworld!"
334 count=5
335 fi
336
337 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
338
339 break
340 fi
341
342 count=$((count + 1))
343 done
344
345 if [ "${PATCH_SUFFIX}" != "patch" ]
346 then
347 rm -f ${PATCH_TARGET}
348 fi
349
350 if [ "${count}" -eq 5 ]
351 then
352 echo
353 eerror "Failed Patch: ${patchname} !"
354 eerror " ( ${PATCH_TARGET} )"
355 eerror
356 eerror "Include in your bugreport the contents of:"
357 eerror
358 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
359 echo
360 die "Failed Patch: ${patchname}!" 532 die "Failed Patch: ${patchname}!"
361 fi 533 fi
362 534
363 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 535 # if everything worked, delete the full debug patch log
536 rm -f "${STDERR_TARGET}"
364 537
538 # then log away the exact stuff for people to review later
539 cat <<-EOF >> "${T}/epatch.log"
540 PATCH: ${x}
541 CMD: ${patch_cmd}
542 PWD: ${PWD}
543
544 EOF
365 eend 0 545 eend 0
366 fi
367 done 546 done
368 if [ "${SINGLE_PATCH}" = "no" ] 547
369 then 548 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
370 einfo "Done with patching" 549 : # everything worked
550}
551
552# @FUNCTION: epatch_user
553# @USAGE:
554# @DESCRIPTION:
555# Applies user-provided patches to the source tree. The patches are
556# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
557# of these three directories to exist will be the one to use, ignoring
558# any more general directories which might exist as well. They must end
559# in ".patch" to be applied.
560#
561# User patches are intended for quick testing of patches without ebuild
562# modifications, as well as for permanent customizations a user might
563# desire. Obviously, there can be no official support for arbitrarily
564# patched ebuilds. So whenever a build log in a bug report mentions that
565# user patches were applied, the user should be asked to reproduce the
566# problem without these.
567#
568# Not all ebuilds do call this function, so placing patches in the
569# stated directory might or might not work, depending on the package and
570# the eclasses it inherits and uses. It is safe to call the function
571# repeatedly, so it is always possible to add a call at the ebuild
572# level. The first call is the time when the patches will be
573# applied.
574#
575# Ideally, this function should be called after gentoo-specific patches
576# have been applied, so that their code can be modified as well, but
577# before calls to e.g. eautoreconf, as the user patches might affect
578# autotool input files as well.
579epatch_user() {
580 [[ $# -ne 0 ]] && die "epatch_user takes no options"
581
582 # Allow multiple calls to this function; ignore all but the first
583 local applied="${T}/epatch_user.log"
584 [[ -e ${applied} ]] && return 2
585
586 # don't clobber any EPATCH vars that the parent might want
587 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
588 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}; do
589 EPATCH_SOURCE=${base}/${CTARGET}/${check}
590 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
591 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
592 if [[ -d ${EPATCH_SOURCE} ]] ; then
593 EPATCH_SOURCE=${EPATCH_SOURCE} \
594 EPATCH_SUFFIX="patch" \
595 EPATCH_FORCE="yes" \
596 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
597 epatch
598 echo "${EPATCH_SOURCE}" > "${applied}"
599 return 0
371 fi 600 fi
601 done
602 echo "none" > "${applied}"
603 return 1
372} 604}
373 605
606# @FUNCTION: emktemp
607# @USAGE: [temp dir]
608# @DESCRIPTION:
374# Cheap replacement for when debianutils (and thus mktemp) 609# Cheap replacement for when debianutils (and thus mktemp)
375# does not exist on the users system 610# does not exist on the users system.
376# vapier@gentoo.org
377#
378# Takes just 1 optional parameter (the directory to create tmpfile in)
379emktemp() { 611emktemp() {
380 local exe="touch" 612 local exe="touch"
381 [ "$1" == "-d" ] && exe="mkdir" && shift 613 [[ $1 == -d ]] && exe="mkdir" && shift
382 local topdir="$1" 614 local topdir=$1
383 615
384 if [ -z "${topdir}" ] 616 if [[ -z ${topdir} ]] ; then
385 then
386 [ -z "${T}" ] \ 617 [[ -z ${T} ]] \
387 && topdir="/tmp" \ 618 && topdir="/tmp" \
388 || topdir="${T}" 619 || topdir=${T}
389 fi 620 fi
390 621
391 if [ -z "$(type -p mktemp)" ] 622 if ! type -P mktemp > /dev/null ; then
392 then 623 # system lacks `mktemp` so we have to fake it
393 local tmp=/ 624 local tmp=/
394 while [ -e "${tmp}" ] ; do 625 while [[ -e ${tmp} ]] ; do
395 tmp="${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}" 626 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
396 done 627 done
397 ${exe} "${tmp}" 628 ${exe} "${tmp}" || ${exe} -p "${tmp}"
398 echo "${tmp}" 629 echo "${tmp}"
399 else 630 else
400 [ "${exe}" == "touch" ] \ 631 # the args here will give slightly wierd names on BSD,
401 && exe="-p" \ 632 # but should produce a usable file on all userlands
402 || exe="-d" 633 if [[ ${exe} == "touch" ]] ; then
403 mktemp ${exe} "${topdir}" 634 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
404 fi
405}
406
407# Small wrapper for getent (Linux), nidump (Mac OS X),
408# and pw (FreeBSD) used in enewuser()/enewgroup()
409# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
410# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
411#
412# egetent(database, key)
413egetent() {
414 if useq ppc-macos ; then
415 case "$2" in
416 *[!0-9]*) # Non numeric
417 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
418 ;;
419 *) # Numeric
420 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
421 ;;
422 esac
423 elif useq x86-fbsd ; then
424 local action
425 if [ "$1" == "passwd" ]
426 then
427 action="user"
428 else 635 else
429 action="group" 636 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
430 fi
431 pw show "${action}" "$2" -q
432 else
433 which nscd >& /dev/null && nscd -i "$1"
434 getent "$1" "$2"
435 fi
436}
437
438# Simplify/standardize adding users to the system
439# vapier@gentoo.org
440#
441# enewuser(username, uid, shell, homedir, groups, extra options)
442#
443# Default values if you do not specify any:
444# username: REQUIRED !
445# uid: next available (see useradd(8))
446# note: pass -1 to get default behavior
447# shell: /bin/false
448# homedir: /dev/null
449# groups: none
450# extra: comment of 'added by portage for ${PN}'
451enewuser() {
452 # get the username
453 local euser="$1"; shift
454 if [ -z "${euser}" ]
455 then
456 eerror "No username specified !"
457 die "Cannot call enewuser without a username"
458 fi
459
460 # lets see if the username already exists
461 if [ "${euser}" == "`egetent passwd \"${euser}\" | cut -d: -f1`" ]
462 then
463 return 0
464 fi
465 einfo "Adding user '${euser}' to your system ..."
466
467 # options to pass to useradd
468 local opts=
469
470 # handle uid
471 local euid="$1"; shift
472 if [ ! -z "${euid}" ] && [ "${euid}" != "-1" ]
473 then
474 if [ "${euid}" -gt 0 ]
475 then
476 if [ ! -z "`egetent passwd ${euid}`" ]
477 then
478 euid="next"
479 fi 637 fi
480 else
481 eerror "Userid given but is not greater than 0 !"
482 die "${euid} is not a valid UID"
483 fi 638 fi
484 else
485 euid="next"
486 fi
487 if [ "${euid}" == "next" ]
488 then
489 local pwrange
490 if [ "${USERLAND}" == "BSD" ] ; then
491 pwrange="`jot 898 101`"
492 else
493 pwrange="`seq 101 999`"
494 fi
495 for euid in ${pwrange} ; do
496 [ -z "`egetent passwd ${euid}`" ] && break
497 done
498 fi
499 opts="${opts} -u ${euid}"
500 einfo " - Userid: ${euid}"
501
502 # handle shell
503 local eshell="$1"; shift
504 if [ ! -z "${eshell}" ] && [ "${eshell}" != "-1" ]
505 then
506 if [ ! -e "${eshell}" ]
507 then
508 eerror "A shell was specified but it does not exist !"
509 die "${eshell} does not exist"
510 fi
511 else
512 if [ "${USERLAND}" == "BSD" ]
513 then
514 eshell="/usr/bin/false"
515 else
516 eshell="/bin/false"
517 fi
518 fi
519 einfo " - Shell: ${eshell}"
520 opts="${opts} -s ${eshell}"
521
522 # handle homedir
523 local ehome="$1"; shift
524 if [ -z "${ehome}" ] && [ "${eshell}" != "-1" ]
525 then
526 ehome="/dev/null"
527 fi
528 einfo " - Home: ${ehome}"
529 opts="${opts} -d ${ehome}"
530
531 # handle groups
532 local egroups="$1"; shift
533 if [ ! -z "${egroups}" ]
534 then
535 local oldifs="${IFS}"
536 local defgroup="" exgroups=""
537
538 export IFS=","
539 for g in ${egroups}
540 do
541 export IFS="${oldifs}"
542 if [ -z "`egetent group \"${g}\"`" ]
543 then
544 eerror "You must add group ${g} to the system first"
545 die "${g} is not a valid GID"
546 fi
547 if [ -z "${defgroup}" ]
548 then
549 defgroup="${g}"
550 else
551 exgroups="${exgroups},${g}"
552 fi
553 export IFS=","
554 done
555 export IFS="${oldifs}"
556
557 opts="${opts} -g ${defgroup}"
558 if [ ! -z "${exgroups}" ]
559 then
560 opts="${opts} -G ${exgroups:1}"
561 fi
562 else
563 egroups="(none)"
564 fi
565 einfo " - Groups: ${egroups}"
566
567 # handle extra and add the user
568 local eextra="$@"
569 local oldsandbox="${SANDBOX_ON}"
570 export SANDBOX_ON="0"
571 if useq ppc-macos
572 then
573 ### Make the user
574 if [ -z "${eextra}" ]
575 then
576 dscl . create /users/${euser} uid ${euid}
577 dscl . create /users/${euser} shell ${eshell}
578 dscl . create /users/${euser} home ${ehome}
579 dscl . create /users/${euser} realname "added by portage for ${PN}"
580 ### Add the user to the groups specified
581 local oldifs="${IFS}"
582 export IFS=","
583 for g in ${egroups}
584 do
585 dscl . merge /groups/${g} users ${euser}
586 done
587 export IFS="${oldifs}"
588 else
589 einfo "Extra options are not supported on macos yet"
590 einfo "Please report the ebuild along with the info below"
591 einfo "eextra: ${eextra}"
592 die "Required function missing"
593 fi
594 elif use x86-fbsd ; then
595 if [ -z "${eextra}" ]
596 then
597 pw useradd ${euser} ${opts} \
598 -c "added by portage for ${PN}" \
599 die "enewuser failed"
600 else
601 einfo " - Extra: ${eextra}"
602 pw useradd ${euser} ${opts} \
603 -c ${eextra} || die "enewuser failed"
604 fi
605 else
606 if [ -z "${eextra}" ]
607 then
608 useradd ${opts} ${euser} \
609 -c "added by portage for ${PN}" \
610 || die "enewuser failed"
611 else
612 einfo " - Extra: ${eextra}"
613 useradd ${opts} ${euser} ${eextra} \
614 || die "enewuser failed"
615 fi
616 fi
617 export SANDBOX_ON="${oldsandbox}"
618
619 if [ ! -e "${ehome}" ] && [ ! -e "${D}/${ehome}" ]
620 then
621 einfo " - Creating ${ehome} in ${D}"
622 dodir ${ehome}
623 fowners ${euser} ${ehome}
624 fperms 755 ${ehome}
625 fi
626} 639}
627 640
628# Simplify/standardize adding groups to the system 641# @FUNCTION: edos2unix
629# vapier@gentoo.org 642# @USAGE: <file> [more files ...]
630# 643# @DESCRIPTION:
631# enewgroup(group, gid) 644# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
632# 645# to remove all of these text utilities from DEPEND variables because this
633# Default values if you do not specify any: 646# is a script based solution. Just give it a list of files to convert and
634# groupname: REQUIRED ! 647# they will all be changed from the DOS CRLF format to the UNIX LF format.
635# gid: next available (see groupadd(8))
636# extra: none
637enewgroup() {
638 # get the group
639 local egroup="$1"; shift
640 if [ -z "${egroup}" ]
641 then
642 eerror "No group specified !"
643 die "Cannot call enewgroup without a group"
644 fi
645
646 # see if group already exists
647 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ]
648 then
649 return 0
650 fi
651 einfo "Adding group '${egroup}' to your system ..."
652
653 # options to pass to useradd
654 local opts=
655
656 # handle gid
657 local egid="$1"; shift
658 if [ ! -z "${egid}" ]
659 then
660 if [ "${egid}" -gt 0 ]
661 then
662 if [ -z "`egetent group ${egid}`" ]
663 then
664 if useq ppc-macos ; then
665 opts="${opts} ${egid}"
666 else
667 opts="${opts} -g ${egid}"
668 fi
669 else
670 egid="next available; requested gid taken"
671 fi
672 else
673 eerror "Groupid given but is not greater than 0 !"
674 die "${egid} is not a valid GID"
675 fi
676 else
677 egid="next available"
678 fi
679 einfo " - Groupid: ${egid}"
680
681 # handle extra
682 local eextra="$@"
683 opts="${opts} ${eextra}"
684
685 # add the group
686 local oldsandbox="${SANDBOX_ON}"
687 export SANDBOX_ON="0"
688 if useq ppc-macos ; then
689 if [ ! -z "${eextra}" ];
690 then
691 einfo "Extra options are not supported on macos yet"
692 einfo "Please report the ebuild along with the info below"
693 einfo "eextra: ${eextra}"
694 die "Required function missing"
695 fi
696
697 # If we need the next available
698 case ${egid} in
699 *[!0-9]*) # Non numeric
700 for egid in `jot 898 101`; do
701 [ -z "`egetent group ${egid}`" ] && break
702 done
703 esac
704 dscl . create /groups/${egroup} gid ${egid}
705 dscl . create /groups/${egroup} passwd '*'
706 elif use x86-fbsd ; then
707 case ${egid} in
708 *[!0-9]*) # Non numeric
709 for egid in `jot 898 101`; do
710 [ -z "`egetent group ${egid}`" ] && break
711 done
712 esac
713 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
714 else
715 groupadd ${opts} ${egroup} || die "enewgroup failed"
716 fi
717 export SANDBOX_ON="${oldsandbox}"
718}
719
720# Simple script to replace 'dos2unix' binaries
721# vapier@gentoo.org
722#
723# edos2unix(file, <more files> ...)
724edos2unix() { 648edos2unix() {
725 for f in "$@" 649 [[ $# -eq 0 ]] && return 0
726 do 650 sed -i 's/\r$//' -- "$@" || die
727 cp "${f}" ${T}/edos2unix
728 sed 's/\r$//' ${T}/edos2unix > "${f}"
729 done
730} 651}
731 652
732 653# @FUNCTION: make_desktop_entry
733############################################################## 654# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
734# START: Handle .desktop files and menu entries # 655# @DESCRIPTION:
735# maybe this should be separated into a new eclass some time #
736# lanius@gentoo.org #
737##############################################################
738
739# Make a desktop file ! 656# Make a .desktop file.
740# Great for making those icons in kde/gnome startmenu !
741# Amaze your friends ! Get the women ! Join today !
742# 657#
743# make_desktop_entry(<binary>, [name], [icon], [type], [path]) 658# @CODE
744#
745# binary: what binary does the app run with ? 659# binary: what command does the app run with ?
746# name: the name that will show up in the menu 660# name: the name that will show up in the menu
747# icon: give your little like a pretty little icon ... 661# icon: give your little like a pretty little icon ...
748# this can be relative (to /usr/share/pixmaps) or 662# this can be relative (to /usr/share/pixmaps) or
749# a full path to an icon 663# a full path to an icon
750# type: what kind of application is this ? for categories: 664# type: what kind of application is this?
751# http://www.freedesktop.org/wiki/Standards_2fmenu_2dspec 665# for categories:
752# path: if your app needs to startup in a specific dir 666# http://standards.freedesktop.org/menu-spec/latest/apa.html
667# if unset, function tries to guess from package's category
668# fields: extra fields to append to the desktop file; a printf string
669# @CODE
753make_desktop_entry() { 670make_desktop_entry() {
754 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 671 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
755 672
756 local exec=${1} 673 local exec=${1}
757 local name=${2:-${PN}} 674 local name=${2:-${PN}}
758 local icon=${3:-${PN}.png} 675 local icon=${3:-${PN}}
759 local type=${4} 676 local type=${4}
760 local path=${5} 677 local fields=${5}
761 678
762 if [[ -z ${type} ]] ; then 679 if [[ -z ${type} ]] ; then
763 local catmaj=${CATEGORY%%-*} 680 local catmaj=${CATEGORY%%-*}
764 local catmin=${CATEGORY##*-} 681 local catmin=${CATEGORY##*-}
765 case ${catmaj} in 682 case ${catmaj} in
766 app) 683 app)
767 case ${catmin} in 684 case ${catmin} in
685 accessibility) type="Utility;Accessibility";;
768 admin) type=System;; 686 admin) type=System;;
687 antivirus) type=System;;
688 arch) type="Utility;Archiving";;
689 backup) type="Utility;Archiving";;
769 cdr) type=DiscBurning;; 690 cdr) type="AudioVideo;DiscBurning";;
770 dicts) type=Dictionary;; 691 dicts) type="Office;Dictionary";;
692 doc) type=Documentation;;
771 editors) type=TextEditor;; 693 editors) type="Utility;TextEditor";;
772 emacs) type=TextEditor;; 694 emacs) type="Development;TextEditor";;
773 emulation) type=Emulator;; 695 emulation) type="System;Emulator";;
774 laptop) type=HardwareSettings;; 696 laptop) type="Settings;HardwareSettings";;
775 office) type=Office;; 697 office) type=Office;;
698 pda) type="Office;PDA";;
776 vim) type=TextEditor;; 699 vim) type="Development;TextEditor";;
777 xemacs) type=TextEditor;; 700 xemacs) type="Development;TextEditor";;
778 *) type=;;
779 esac 701 esac
780 ;; 702 ;;
781 703
782 dev) 704 dev)
783 type="Development" 705 type="Development"
784 ;; 706 ;;
785 707
786 games) 708 games)
787 [[ -z ${path} ]] && path=${GAMES_BINDIR}
788
789 case ${catmin} in 709 case ${catmin} in
790 action) type=ActionGame;; 710 action|fps) type=ActionGame;;
791 arcade) type=ArcadeGame;; 711 arcade) type=ArcadeGame;;
792 board) type=BoardGame;; 712 board) type=BoardGame;;
793 kid) type=KidsGame;;
794 emulation) type=Emulator;; 713 emulation) type=Emulator;;
714 kids) type=KidsGame;;
795 puzzle) type=LogicGame;; 715 puzzle) type=LogicGame;;
716 roguelike) type=RolePlaying;;
796 rpg) type=RolePlaying;; 717 rpg) type=RolePlaying;;
797 roguelike) type=RolePlaying;;
798 simulation) type=Simulation;; 718 simulation) type=Simulation;;
799 sports) type=SportsGame;; 719 sports) type=SportsGame;;
800 strategy) type=StrategyGame;; 720 strategy) type=StrategyGame;;
801 *) type=;;
802 esac 721 esac
803 type="Game;${type}" 722 type="Game;${type}"
804 ;; 723 ;;
805 724
725 gnome)
726 type="Gnome;GTK"
727 ;;
728
729 kde)
730 type="KDE;Qt"
731 ;;
732
806 mail) 733 mail)
807 type="Network;Email" 734 type="Network;Email"
808 ;; 735 ;;
809 736
810 media) 737 media)
811 case ${catmin} in 738 case ${catmin} in
739 gfx)
812 gfx) type=Graphics;; 740 type=Graphics
741 ;;
742 *)
743 case ${catmin} in
813 radio) type=Tuner;; 744 radio) type=Tuner;;
814 sound) type=Audio;; 745 sound) type=Audio;;
815 tv) type=TV;; 746 tv) type=TV;;
816 video) type=Video;; 747 video) type=Video;;
817 *) type=;; 748 esac
749 type="AudioVideo;${type}"
750 ;;
818 esac 751 esac
819 type="AudioVideo;${type}"
820 ;; 752 ;;
821 753
822 net) 754 net)
823 case ${catmin} in 755 case ${catmin} in
824 dialup) type=Dialup;; 756 dialup) type=Dialup;;
827 irc) type=IRCClient;; 759 irc) type=IRCClient;;
828 mail) type=Email;; 760 mail) type=Email;;
829 news) type=News;; 761 news) type=News;;
830 nntp) type=News;; 762 nntp) type=News;;
831 p2p) type=FileTransfer;; 763 p2p) type=FileTransfer;;
832 *) type=;; 764 voip) type=Telephony;;
833 esac 765 esac
834 type="Network;${type}" 766 type="Network;${type}"
835 ;; 767 ;;
836 768
837 sci) 769 sci)
838 case ${catmin} in 770 case ${catmin} in
839 astro*) type=Astronomoy;; 771 astro*) type=Astronomy;;
840 bio*) type=Biology;; 772 bio*) type=Biology;;
841 calc*) type=Calculator;; 773 calc*) type=Calculator;;
842 chem*) type=Chemistry;; 774 chem*) type=Chemistry;;
775 elec*) type=Electronics;;
843 geo*) type=Geology;; 776 geo*) type=Geology;;
844 math*) type=Math;; 777 math*) type=Math;;
845 *) type=;; 778 physics) type=Physics;;
779 visual*) type=DataVisualization;;
846 esac 780 esac
847 type="Science;${type}" 781 type="Education;Science;${type}"
782 ;;
783
784 sys)
785 type="System"
848 ;; 786 ;;
849 787
850 www) 788 www)
851 case ${catmin} in 789 case ${catmin} in
852 client) type=WebBrowser;; 790 client) type=WebBrowser;;
853 *) type=;;
854 esac 791 esac
855 type="Network" 792 type="Network;${type}"
856 ;; 793 ;;
857 794
858 *) 795 *)
859 type= 796 type=
860 ;; 797 ;;
861 esac 798 esac
862 fi 799 fi
863 800 if [ "${SLOT}" == "0" ] ; then
801 local desktop_name="${PN}"
802 else
803 local desktop_name="${PN}-${SLOT}"
804 fi
805 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
864 local desktop=${T}/${exec%% *}-${P}.desktop 806 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
865 807
808 # Don't append another ";" when a valid category value is provided.
809 type=${type%;}${type:+;}
810
811 eshopts_push -s extglob
812 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
813 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
814 ewarn "allowed in .desktop files if the value is not an absolute path."
815 icon=${icon%.@(xpm|png|svg)}
816 fi
817 eshopts_pop
818
819 cat <<-EOF > "${desktop}"
866echo "[Desktop Entry] 820 [Desktop Entry]
867Encoding=UTF-8
868Version=0.9.2
869Name=${name} 821 Name=${name}
870Type=Application 822 Type=Application
871Comment=${DESCRIPTION} 823 Comment=${DESCRIPTION}
872Exec=${exec} 824 Exec=${exec}
873Path=${path} 825 TryExec=${exec%% *}
874Icon=${icon} 826 Icon=${icon}
875Categories=Application;${type};" > "${desktop}" 827 Categories=${type}
828 EOF
876 829
830 if [[ ${fields:-=} != *=* ]] ; then
831 # 5th arg used to be value to Path=
832 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
833 fields="Path=${fields}"
834 fi
835 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
836
837 (
838 # wrap the env here so that the 'insinto' call
839 # doesn't corrupt the env of the caller
877 insinto /usr/share/applications 840 insinto /usr/share/applications
878 doins "${desktop}" 841 doins "${desktop}"
879 842 ) || die "installing desktop file failed"
880 return 0
881} 843}
882 844
883# Make a GDM/KDM Session file 845# @FUNCTION: validate_desktop_entries
884# 846# @USAGE: [directories]
885# make_desktop_entry(<title>, <command>) 847# @MAINTAINER:
886# title: File to execute to start the Window Manager 848# Carsten Lohrke <carlo@gentoo.org>
887# command: Name of the Window Manager 849# @DESCRIPTION:
850# Validate desktop entries using desktop-file-utils
851validate_desktop_entries() {
852 if [[ -x /usr/bin/desktop-file-validate ]] ; then
853 einfo "Checking desktop entry validity"
854 local directories=""
855 for d in /usr/share/applications $@ ; do
856 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
857 done
858 if [[ -n ${directories} ]] ; then
859 for FILE in $(find ${directories} -name "*\.desktop" \
860 -not -path '*.hidden*' | sort -u 2>/dev/null)
861 do
862 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
863 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
864 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
865 done
866 fi
867 echo ""
868 else
869 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
870 fi
871}
888 872
873# @FUNCTION: make_session_desktop
874# @USAGE: <title> <command> [command args...]
875# @DESCRIPTION:
876# Make a GDM/KDM Session file. The title is the file to execute to start the
877# Window Manager. The command is the name of the Window Manager.
878#
879# You can set the name of the file via the ${wm} variable.
889make_session_desktop() { 880make_session_desktop() {
890 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 881 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
891 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 882 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
892 883
893 local title=$1 884 local title=$1
894 local command=$2 885 local command=$2
895 local desktop=${T}/${wm}.desktop 886 local desktop=${T}/${wm:-${PN}}.desktop
887 shift 2
896 888
889 cat <<-EOF > "${desktop}"
897echo "[Desktop Entry] 890 [Desktop Entry]
898Encoding=UTF-8
899Name=${title} 891 Name=${title}
900Comment=This session logs you into ${title} 892 Comment=This session logs you into ${title}
901Exec=${command} 893 Exec=${command} $*
902TryExec=${command} 894 TryExec=${command}
903Type=Application" > "${desktop}" 895 Type=XSession
896 EOF
904 897
898 (
899 # wrap the env here so that the 'insinto' call
900 # doesn't corrupt the env of the caller
905 insinto /usr/share/xsessions 901 insinto /usr/share/xsessions
906 doins "${desktop}" 902 doins "${desktop}"
903 )
907} 904}
908 905
906# @FUNCTION: domenu
907# @USAGE: <menus>
908# @DESCRIPTION:
909# Install the list of .desktop menu files into the appropriate directory
910# (/usr/share/applications).
909domenu() { 911domenu() {
912 (
913 # wrap the env here so that the 'insinto' call
914 # doesn't corrupt the env of the caller
910 local i j 915 local i j ret=0
911 insinto /usr/share/applications 916 insinto /usr/share/applications
912 for i in "$@" ; do 917 for i in "$@" ; do
913 if [[ -f ${i} ]] ; then 918 if [[ -f ${i} ]] ; then
914 doins "${i}" 919 doins "${i}"
920 ((ret+=$?))
915 elif [[ -d ${i} ]] ; then 921 elif [[ -d ${i} ]] ; then
916 for j in "${i}"/*.desktop ; do 922 for j in "${i}"/*.desktop ; do
917 doins "${j}" 923 doins "${j}"
924 ((ret+=$?))
918 done 925 done
926 else
927 ((++ret))
919 fi 928 fi
920 done 929 done
930 exit ${ret}
931 )
921} 932}
933
934# @FUNCTION: newmenu
935# @USAGE: <menu> <newname>
936# @DESCRIPTION:
937# Like all other new* functions, install the specified menu as newname.
922newmenu() { 938newmenu() {
939 (
940 # wrap the env here so that the 'insinto' call
941 # doesn't corrupt the env of the caller
923 insinto /usr/share/applications 942 insinto /usr/share/applications
924 newins "$1" "$2" 943 newins "$@"
944 )
925} 945}
926 946
927doicon() { 947# @FUNCTION: _iconins
928 local i j 948# @INTERNAL
929 insinto /usr/share/pixmaps 949# @DESCRIPTION:
930 for i in "$@" ; do 950# function for use in doicon and newicon
931 if [[ -f ${i} ]] ; then 951_iconins() {
932 doins "${i}" 952 (
933 elif [[ -d ${i} ]] ; then 953 # wrap the env here so that the 'insinto' call
934 for j in "${i}"/*.png ; do 954 # doesn't corrupt the env of the caller
935 doins "${j}" 955 local funcname=$1; shift
936 done 956 local size dir
937 fi 957 local context=apps
938 done 958 local theme=hicolor
939}
940newicon() {
941 insinto /usr/share/pixmaps
942 newins "$1" "$2"
943}
944 959
945############################################################## 960 while [[ $# -gt 0 ]] ; do
946# END: Handle .desktop files and menu entries # 961 case $1 in
947############################################################## 962 -s|--size)
948 963 if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
949 964 size=${2%%x*}
950# for internal use only (unpack_pdv and unpack_makeself)
951find_unpackable_file() {
952 local src="$1"
953 if [ -z "${src}" ]
954 then
955 src="${DISTDIR}/${A}"
956 else
957 if [ -e "${DISTDIR}/${src}" ]
958 then
959 src="${DISTDIR}/${src}"
960 elif [ -e "${PWD}/${src}" ]
961 then
962 src="${PWD}/${src}"
963 elif [ -e "${src}" ]
964 then
965 src="${src}"
966 fi
967 fi
968 [ ! -e "${src}" ] && die "Could not find requested archive ${src}"
969 echo "${src}"
970}
971
972# Unpack those pesky pdv generated files ...
973# They're self-unpacking programs with the binary package stuffed in
974# the middle of the archive. Valve seems to use it a lot ... too bad
975# it seems to like to segfault a lot :(. So lets take it apart ourselves.
976#
977# Usage: unpack_pdv [file to unpack] [size of off_t]
978# - you have to specify the off_t size ... i have no idea how to extract that
979# information out of the binary executable myself. basically you pass in
980# the size of the off_t type (in bytes) on the machine that built the pdv
981# archive. one way to determine this is by running the following commands:
982# strings <pdv archive> | grep lseek
983# strace -elseek <pdv archive>
984# basically look for the first lseek command (we do the strings/grep because
985# sometimes the function call is _llseek or something) and steal the 2nd
986# parameter. here is an example:
987# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
988# lseek
989# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
990# lseek(3, -4, SEEK_END) = 2981250
991# thus we would pass in the value of '4' as the second parameter.
992unpack_pdv() {
993 local src="`find_unpackable_file $1`"
994 local sizeoff_t="$2"
995
996 [ -z "${sizeoff_t}" ] && die "No idea what off_t size was used for this pdv :("
997
998 local shrtsrc="`basename ${src}`"
999 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1000 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
1001 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
1002
1003 # grab metadata for debug reasons
1004 local metafile="$(emktemp)"
1005 tail -c +$((${metaskip}+1)) ${src} > ${metafile}
1006
1007 # rip out the final file name from the metadata
1008 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`"
1009 datafile="`basename ${datafile}`"
1010
1011 # now lets uncompress/untar the file if need be
1012 local tmpfile="$(emktemp)"
1013 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1014
1015 local iscompressed="`file -b ${tmpfile}`"
1016 if [ "${iscompressed:0:8}" == "compress" ] ; then
1017 iscompressed=1
1018 mv ${tmpfile}{,.Z}
1019 gunzip ${tmpfile}
1020 else
1021 iscompressed=0
1022 fi
1023 local istar="`file -b ${tmpfile}`"
1024 if [ "${istar:0:9}" == "POSIX tar" ] ; then
1025 istar=1
1026 else
1027 istar=0
1028 fi
1029
1030 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1031 #dd if=${src} ibs=${metaskip} count=1 \
1032 # | dd ibs=${tailskip} skip=1 \
1033 # | gzip -dc \
1034 # > ${datafile}
1035 if [ ${iscompressed} -eq 1 ] ; then
1036 if [ ${istar} -eq 1 ] ; then
1037 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1038 | head -c $((${metaskip}-${tailskip})) \
1039 | tar -xzf -
1040 else 965 else
1041 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \ 966 size=${2}
1042 | head -c $((${metaskip}-${tailskip})) \
1043 | gzip -dc \
1044 > ${datafile}
1045 fi 967 fi
1046 else
1047 if [ ${istar} -eq 1 ] ; then
1048 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1049 | head -c $((${metaskip}-${tailskip})) \
1050 | tar --no-same-owner -xf -
1051 else
1052 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1053 | head -c $((${metaskip}-${tailskip})) \
1054 > ${datafile}
1055 fi
1056 fi
1057 true
1058 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1059 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1060}
1061
1062# Unpack those pesky makeself generated files ...
1063# They're shell scripts with the binary package tagged onto
1064# the end of the archive. Loki utilized the format as does
1065# many other game companies.
1066#
1067# Usage: unpack_makeself [file to unpack] [offset] [tail|dd]
1068# - If the file is not specified then unpack will utilize ${A}.
1069# - If the offset is not specified then we will attempt to extract
1070# the proper offset from the script itself.
1071unpack_makeself() {
1072 local src="$(find_unpackable_file "$1")"
1073 local skip="$2"
1074 local exe="$3"
1075
1076 local shrtsrc="$(basename "${src}")"
1077 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1078 if [ -z "${skip}" ]
1079 then
1080 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`"
1081 local skip=0
1082 exe=tail
1083 case ${ver} in 968 case ${size} in
1084 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 969 16|22|24|32|36|48|64|72|96|128|192|256)
1085 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 970 size=${size}x${size};;
1086 ;; 971 scalable)
1087 2.0|2.0.1)
1088 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1089 ;;
1090 2.1.1)
1091 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1092 let skip="skip + 1"
1093 ;;
1094 2.1.2)
1095 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1096 let skip="skip + 1"
1097 ;;
1098 2.1.3)
1099 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1100 let skip="skip + 1"
1101 ;;
1102 2.1.4)
1103 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1104 skip=$(head -n ${skip} "${src}" | wc -c)
1105 exe="dd"
1106 ;; 972 ;;
1107 *) 973 *)
1108 eerror "I'm sorry, but I was unable to support the Makeself file." 974 eerror "${size} is an unsupported icon size!"
1109 eerror "The version I detected was '${ver}'." 975 exit 1;;
1110 eerror "Please file a bug about the file ${shrtsrc} at" 976 esac
1111 eerror "http://bugs.gentoo.org/ so that support can be added." 977 shift 2;;
1112 die "makeself version '${ver}' not supported" 978 -t|--theme)
1113 ;; 979 theme=${2}
980 shift 2;;
981 -c|--context)
982 context=${2}
983 shift 2;;
984 *)
985 if [[ -z ${size} ]] ; then
986 insinto /usr/share/pixmaps
987 else
988 insinto /usr/share/icons/${theme}/${size}/${context}
989 fi
990
991 if [[ ${funcname} == doicon ]] ; then
992 if [[ -f $1 ]] ; then
993 doins "${1}"
994 elif [[ -d $1 ]] ; then
995 shopt -s nullglob
996 doins "${1}"/*.{png,svg}
997 shopt -u nullglob
998 else
999 eerror "${1} is not a valid file/directory!"
1000 exit 1
1001 fi
1002 else
1003 break
1004 fi
1005 shift 1;;
1114 esac 1006 esac
1115 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1116 fi
1117 case ${exe} in
1118 tail) exe="tail -n +${skip} '${src}'";;
1119 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";;
1120 *) die "makeself cant handle exe '${exe}'"
1121 esac
1122
1123 # lets grab the first few bytes of the file to figure out what kind of archive it is
1124 local tmpfile="$(emktemp)"
1125 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1126 local filetype="$(file -b "${tmpfile}")"
1127 case ${filetype} in
1128 *tar\ archive)
1129 eval ${exe} | tar --no-same-owner -xf -
1130 ;;
1131 bzip2*)
1132 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1133 ;;
1134 gzip*)
1135 eval ${exe} | tar --no-same-owner -xzf -
1136 ;;
1137 compress*)
1138 eval ${exe} | gunzip | tar --no-same-owner -xf -
1139 ;;
1140 *)
1141 eerror "Unknown filetype \"${filetype}\" ?"
1142 false
1143 ;;
1144 esac
1145 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1146}
1147
1148# Display a license for user to accept.
1149#
1150# Usage: check_license [license]
1151# - If the file is not specified then ${LICENSE} is used.
1152check_license() {
1153 local lic=$1
1154 if [ -z "${lic}" ] ; then
1155 lic="${PORTDIR}/licenses/${LICENSE}"
1156 else
1157 if [ -e "${PORTDIR}/licenses/${src}" ] ; then
1158 lic="${PORTDIR}/licenses/${src}"
1159 elif [ -e "${PWD}/${src}" ] ; then
1160 lic="${PWD}/${src}"
1161 elif [ -e "${src}" ] ; then
1162 lic="${src}"
1163 fi
1164 fi
1165 [ ! -f "${lic}" ] && die "Could not find requested license ${src}"
1166 local l="`basename ${lic}`"
1167
1168 # here is where we check for the licenses the user already
1169 # accepted ... if we don't find a match, we make the user accept
1170 local shopts=$-
1171 local alic
1172 set -o noglob #so that bash doesn't expand "*"
1173 for alic in ${ACCEPT_LICENSE} ; do
1174 if [[ ${alic} == * || ${alic} == ${l} ]]; then
1175 set +o noglob; set -${shopts} #reset old shell opts
1176 return 0
1177 fi
1178 done 1007 done
1179 set +o noglob; set -$shopts #reset old shell opts 1008 if [[ ${funcname} == newicon ]] ; then
1180 1009 newins "$@"
1181 local licmsg="$(emktemp)"
1182 cat << EOF > ${licmsg}
1183**********************************************************
1184The following license outlines the terms of use of this
1185package. You MUST accept this license for installation to
1186continue. When you are done viewing, hit 'q'. If you
1187CTRL+C out of this, the install will not run!
1188**********************************************************
1189
1190EOF
1191 cat ${lic} >> ${licmsg}
1192 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1193 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1194 read alic
1195 case ${alic} in
1196 yes|Yes|y|Y)
1197 return 0
1198 ;;
1199 *)
1200 echo;echo;echo
1201 eerror "You MUST accept the license to continue! Exiting!"
1202 die "Failed to accept license"
1203 ;;
1204 esac
1205}
1206
1207# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1208# the whole 'non-interactive' policy, but damnit I want CD support !
1209#
1210# with these cdrom functions we handle all the user interaction and
1211# standardize everything. all you have to do is call cdrom_get_cds()
1212# and when the function returns, you can assume that the cd has been
1213# found at CDROM_ROOT.
1214#
1215# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1216# etc... if you want to give the cds better names, then just export
1217# the CDROM_NAME_X variables before calling cdrom_get_cds().
1218#
1219# for those multi cd ebuilds, see the cdrom_load_next_cd() below.
1220#
1221# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1222# - this will attempt to locate a cd based upon a file that is on
1223# the cd ... the more files you give this function, the more cds
1224# the cdrom functions will handle
1225cdrom_get_cds() {
1226 # first we figure out how many cds we're dealing with by
1227 # the # of files they gave us
1228 local cdcnt=0
1229 local f=
1230 for f in "$@" ; do
1231 cdcnt=$((cdcnt + 1))
1232 export CDROM_CHECK_${cdcnt}="$f"
1233 done
1234 export CDROM_TOTAL_CDS=${cdcnt}
1235 export CDROM_CURRENT_CD=1
1236
1237 # now we see if the user gave use CD_ROOT ...
1238 # if they did, let's just believe them that it's correct
1239 if [[ ! -z ${CD_ROOT} ]] ; then
1240 export CDROM_ROOT=${CD_ROOT}
1241 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1242 return
1243 fi
1244 # do the same for CD_ROOT_X
1245 if [[ ! -z ${CD_ROOT_1} ]] ; then
1246 local var=
1247 cdcnt=0
1248 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1249 cdcnt=$((cdcnt + 1))
1250 var="CD_ROOT_${cdcnt}"
1251 if [[ -z ${!var} ]] ; then
1252 eerror "You must either use just the CD_ROOT"
1253 eerror "or specify ALL the CD_ROOT_X variables."
1254 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1255 die "could not locate CD_ROOT_${cdcnt}"
1256 fi
1257 export CDROM_ROOTS_${cdcnt}="${!var}"
1258 done
1259 export CDROM_ROOT=${CDROM_ROOTS_1}
1260 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1261 return
1262 fi
1263
1264 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1265 einfon "This ebuild will need the "
1266 if [[ -z ${CDROM_NAME} ]] ; then
1267 echo "cdrom for ${PN}."
1268 else
1269 echo "${CDROM_NAME}."
1270 fi 1010 fi
1271 echo 1011 ) || die
1272 einfo "If you do not have the CD, but have the data files"
1273 einfo "mounted somewhere on your filesystem, just export"
1274 einfo "the variable CD_ROOT so that it points to the"
1275 einfo "directory containing the files."
1276 echo
1277 einfo "For example:"
1278 einfo "export CD_ROOT=/mnt/cdrom"
1279 echo
1280 else
1281 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1282 cdcnt=0
1283 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1284 cdcnt=$((cdcnt + 1))
1285 var="CDROM_NAME_${cdcnt}"
1286 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1287 done
1288 echo
1289 einfo "If you do not have the CDs, but have the data files"
1290 einfo "mounted somewhere on your filesystem, just export"
1291 einfo "the following variables so they point to the right place:"
1292 einfon ""
1293 cdcnt=0
1294 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1295 cdcnt=$((cdcnt + 1))
1296 echo -n " CD_ROOT_${cdcnt}"
1297 done
1298 echo
1299 einfo "Or, if you have all the files in the same place, or"
1300 einfo "you only have one cdrom, you can export CD_ROOT"
1301 einfo "and that place will be used as the same data source"
1302 einfo "for all the CDs."
1303 echo
1304 einfo "For example:"
1305 einfo "export CD_ROOT_1=/mnt/cdrom"
1306 echo
1307 fi
1308 export CDROM_CURRENT_CD=0
1309 cdrom_load_next_cd
1310} 1012}
1311 1013
1312# this is only used when you need access to more than one cd. 1014# @FUNCTION: doicon
1313# when you have finished using the first cd, just call this function. 1015# @USAGE: [options] <icons>
1314# when it returns, CDROM_ROOT will be pointing to the second cd. 1016# @DESCRIPTION:
1315# remember, you can only go forward in the cd chain, you can't go back. 1017# Install icon into the icon directory /usr/share/icons or into
1316cdrom_load_next_cd() { 1018# /usr/share/pixmaps if "--size" is not set.
1317 export CDROM_CURRENT_CD=$((CDROM_CURRENT_CD + 1)) 1019# This is useful in conjunction with creating desktop/menu files.
1318 local var= 1020#
1319 1021# @CODE
1320 if [[ ! -z ${CD_ROOT} ]] ; then 1022# options:
1321 einfo "Using same root as before for CD #${CDROM_CURRENT_CD}" 1023# -s, --size
1322 return 1024# !!! must specify to install into /usr/share/icons/... !!!
1323 fi 1025# size of the icon, like 48 or 48x48
1324 1026# supported icon sizes are:
1325 unset CDROM_ROOT 1027# 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1326 var=CDROM_ROOTS_${CDROM_CURRENT_CD} 1028# -c, --context
1327 if [[ -z ${!var} ]] ; then 1029# defaults to "apps"
1328 var="CDROM_CHECK_${CDROM_CURRENT_CD}" 1030# -t, --theme
1329 cdrom_locate_file_on_cd ${!var} 1031# defaults to "hicolor"
1330 else 1032#
1331 export CDROM_ROOT=${!var} 1033# icons: list of icons
1332 fi 1034#
1333 1035# example 1: doicon foobar.png fuqbar.svg suckbar.png
1334 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1036# results in: insinto /usr/share/pixmaps
1037# doins foobar.png fuqbar.svg suckbar.png
1038#
1039# example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
1040# results in: insinto /usr/share/icons/hicolor/48x48/apps
1041# doins foobar.png fuqbar.png blobbar.png
1042# @CODE
1043doicon() {
1044 _iconins ${FUNCNAME} "$@"
1335} 1045}
1336 1046
1337# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd() 1047# @FUNCTION: newicon
1338# functions. this should *never* be called from an ebuild. 1048# @USAGE: [options] <icon> <newname>
1339# all it does is try to locate a give file on a cd ... if the cd isn't 1049# @DESCRIPTION:
1340# found, then a message asking for the user to insert the cdrom will be 1050# Like doicon, install the specified icon as newname.
1341# displayed and we'll hang out here until: 1051#
1342# (1) the file is found on a mounted cdrom 1052# @CODE
1343# (2) the user hits CTRL+C 1053# example 1: newicon foobar.png NEWNAME.png
1344cdrom_locate_file_on_cd() { 1054# results in: insinto /usr/share/pixmaps
1345 while [[ -z ${CDROM_ROOT} ]] ; do 1055# newins foobar.png NEWNAME.png
1346 local dir="$(dirname ${@})" 1056#
1347 local file="$(basename ${@})" 1057# example 2: newicon -s 48 foobar.png NEWNAME.png
1348 local mline="" 1058# results in: insinto /usr/share/icons/hicolor/48x48/apps
1349 local showedmsg=0 1059# newins foobar.png NEWNAME.png
1350 1060# @CODE
1351 for mline in $(mount | egrep -e '(iso|cdrom)' | awk '{print $3}') ; do 1061newicon() {
1352 [[ -d ${mline}/${dir} ]] || continue 1062 _iconins ${FUNCNAME} "$@"
1353 [[ ! -z $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] \
1354 && export CDROM_ROOT=${mline}
1355 done
1356
1357 if [[ -z ${CDROM_ROOT} ]] ; then
1358 echo
1359 if [[ ${showedmsg} -eq 0 ]] ; then
1360 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1361 if [[ -z ${CDROM_NAME} ]] ; then
1362 einfo "Please insert the cdrom for ${PN} now !"
1363 else
1364 einfo "Please insert the ${CDROM_NAME} cdrom now !"
1365 fi
1366 else
1367 if [[ -z ${CDROM_NAME_1} ]] ; then
1368 einfo "Please insert cd #${CDROM_CURRENT_CD} for ${PN} now !"
1369 else
1370 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1371 einfo "Please insert+mount the ${!var} cdrom now !"
1372 fi
1373 fi
1374 showedmsg=1
1375 fi
1376 einfo "Press return to scan for the cd again"
1377 einfo "or hit CTRL+C to abort the emerge."
1378 read
1379 fi
1380 done
1381} 1063}
1382 1064
1065# @FUNCTION: strip-linguas
1066# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1067# @DESCRIPTION:
1383# Make sure that LINGUAS only contains languages that 1068# Make sure that LINGUAS only contains languages that
1384# a package can support 1069# a package can support. The first form allows you to
1385# 1070# specify a list of LINGUAS. The -i builds a list of po
1386# usage: strip-linguas <allow LINGUAS> 1071# files found in all the directories and uses the
1387# strip-linguas -i <directories of .po files> 1072# intersection of the lists. The -u builds a list of po
1388# strip-linguas -u <directories of .po files> 1073# files found in all the directories and uses the union
1389# 1074# of the lists.
1390# The first form allows you to specify a list of LINGUAS.
1391# The -i builds a list of po files found in all the
1392# directories and uses the intersection of the lists.
1393# The -u builds a list of po files found in all the
1394# directories and uses the union of the lists.
1395strip-linguas() { 1075strip-linguas() {
1396 local ls newls 1076 local ls newls nols
1397 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1077 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1398 local op=$1; shift 1078 local op=$1; shift
1399 ls=" $(find "$1" -name '*.po' -printf '%f ') "; shift 1079 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1400 local d f 1080 local d f
1401 for d in "$@" ; do 1081 for d in "$@" ; do
1402 if [[ ${op} == "-u" ]] ; then 1082 if [[ ${op} == "-u" ]] ; then
1403 newls=${ls} 1083 newls=${ls}
1404 else 1084 else
1405 newls="" 1085 newls=""
1406 fi 1086 fi
1407 for f in $(find "$d" -name '*.po' -printf '%f ') ; do 1087 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1408 if [[ ${op} == "-i" ]] ; then 1088 if [[ ${op} == "-i" ]] ; then
1409 [[ ${ls/ ${f} /} != ${ls} ]] && newls="${newls} ${f}" 1089 has ${f} ${ls} && newls="${newls} ${f}"
1410 else 1090 else
1411 [[ ${ls/ ${f} /} == ${ls} ]] && newls="${newls} ${f}" 1091 has ${f} ${ls} || newls="${newls} ${f}"
1412 fi 1092 fi
1413 done 1093 done
1414 ls=${newls} 1094 ls=${newls}
1415 done 1095 done
1416 ls=${ls//.po}
1417 else 1096 else
1418 ls=$@ 1097 ls="$@"
1419 fi 1098 fi
1420 1099
1421 ls=" ${ls} " 1100 nols=""
1422 newls="" 1101 newls=""
1423 for f in ${LINGUAS} ; do 1102 for f in ${LINGUAS} ; do
1424 if [[ ${ls/ ${f} /} != ${ls} ]] ; then 1103 if has ${f} ${ls} ; then
1425 newls="${newls} ${f}" 1104 newls="${newls} ${f}"
1426 else 1105 else
1427 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1106 nols="${nols} ${f}"
1428 fi 1107 fi
1429 done 1108 done
1430 if [[ -z ${newls} ]] ; then 1109 [[ -n ${nols} ]] \
1431 export LINGUAS="" 1110 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1432 else
1433 export LINGUAS=${newls:1} 1111 export LINGUAS=${newls:1}
1434 fi
1435} 1112}
1436 1113
1437# moved from kernel.eclass since they are generally useful outside of 1114# @FUNCTION: preserve_old_lib
1438# kernel.eclass -iggy (20041002) 1115# @USAGE: <libs to preserve> [more libs]
1439 1116# @DESCRIPTION:
1440# the following functions are useful in kernel module ebuilds, etc.
1441# for an example see ivtv or drbd ebuilds
1442
1443# set's ARCH to match what the kernel expects
1444set_arch_to_kernel() {
1445 i=10
1446 while ((i--)) ; do
1447 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1448 done
1449 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1450 case ${ARCH} in
1451 x86) export ARCH="i386";;
1452 amd64) export ARCH="x86_64";;
1453 hppa) export ARCH="parisc";;
1454 mips) export ARCH="mips";;
1455 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1456 *) export ARCH="${ARCH}";;
1457 esac
1458}
1459
1460# set's ARCH back to what portage expects
1461set_arch_to_portage() {
1462 i=10
1463 while ((i--)) ; do
1464 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1465 done
1466 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1467}
1468
1469# Jeremy Huddleston <eradicator@gentoo.org>:
1470# preserve_old_lib /path/to/libblah.so.0
1471# preserve_old_lib_notify /path/to/libblah.so.0
1472#
1473# These functions are useful when a lib in your package changes --soname. Such 1117# These functions are useful when a lib in your package changes ABI SONAME.
1474# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1118# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1475# would break packages that link against it. Most people get around this 1119# would break packages that link against it. Most people get around this
1476# by using the portage SLOT mechanism, but that is not always a relevant 1120# by using the portage SLOT mechanism, but that is not always a relevant
1477# solution, so instead you can add the following to your ebuilds: 1121# solution, so instead you can call this from pkg_preinst. See also the
1478# 1122# preserve_old_lib_notify function.
1479# src_install() {
1480# ...
1481# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1482# ...
1483# }
1484#
1485# pkg_postinst() {
1486# ...
1487# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1488# ...
1489# }
1490
1491preserve_old_lib() { 1123preserve_old_lib() {
1492 LIB=$1 1124 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1125 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1126 die "Invalid preserve_old_lib() usage"
1127 fi
1128 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1493 1129
1494 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1130 # let portage worry about it
1495 SONAME=`basename ${LIB}` 1131 has preserve-libs ${FEATURES} && return 0
1496 DIRNAME=`dirname ${LIB}`
1497 1132
1498 dodir ${DIRNAME} 1133 local lib dir
1499 cp ${ROOT}${LIB} ${D}${DIRNAME} 1134 for lib in "$@" ; do
1135 [[ -e ${ROOT}/${lib} ]] || continue
1136 dir=${lib%/*}
1137 dodir ${dir} || die "dodir ${dir} failed"
1138 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1500 touch ${D}${LIB} 1139 touch "${D}"/${lib}
1501 fi 1140 done
1502} 1141}
1503 1142
1143# @FUNCTION: preserve_old_lib_notify
1144# @USAGE: <libs to notify> [more libs]
1145# @DESCRIPTION:
1146# Spit helpful messages about the libraries preserved by preserve_old_lib.
1504preserve_old_lib_notify() { 1147preserve_old_lib_notify() {
1505 LIB=$1 1148 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1149 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1150 die "Invalid preserve_old_lib_notify() usage"
1151 fi
1506 1152
1507 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1153 # let portage worry about it
1508 SONAME=`basename ${LIB}` 1154 has preserve-libs ${FEATURES} && return 0
1509 1155
1156 local lib notice=0
1157 for lib in "$@" ; do
1158 [[ -e ${ROOT}/${lib} ]] || continue
1159 if [[ ${notice} -eq 0 ]] ; then
1160 notice=1
1510 einfo "An old version of an installed library was detected on your system." 1161 ewarn "Old versions of installed libraries were detected on your system."
1511 einfo "In order to avoid breaking packages that link against is, this older version" 1162 ewarn "In order to avoid breaking packages that depend on these old libs,"
1512 einfo "is not being removed. In order to make full use of this newer version," 1163 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1513 einfo "you will need to execute the following command:" 1164 ewarn "in order to remove these old dependencies. If you do not have this"
1514 einfo " revdep-rebuild --soname ${SONAME}" 1165 ewarn "helper program, simply emerge the 'gentoolkit' package."
1515 einfo 1166 ewarn
1516 einfo "After doing that, you can safely remove ${LIB}"
1517 einfo "Note: 'emerge gentoolkit' to get revdep-rebuild"
1518 fi 1167 fi
1168 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1169 done
1519} 1170}
1520 1171
1521# Hack for people to figure out if a package was built with 1172# @FUNCTION: built_with_use
1522# certain USE flags 1173# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1174# @DESCRIPTION:
1523# 1175#
1524# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1176# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1525# ex: built_with_use xchat gtk2
1526# 1177#
1527# Flags: -a all USE flags should be utilized 1178# A temporary hack until portage properly supports DEPENDing on USE
1528# -o at least one USE flag should be utilized 1179# flags being enabled in packages. This will check to see if the specified
1529# Note: the default flag is '-a' 1180# DEPEND atom was built with the specified list of USE flags. The
1181# --missing option controls the behavior if called on a package that does
1182# not actually support the defined USE flags (aka listed in IUSE).
1183# The default is to abort (call die). The -a and -o flags control
1184# the requirements of the USE flags. They correspond to "and" and "or"
1185# logic. So the -a flag means all listed USE flags must be enabled
1186# while the -o flag means at least one of the listed IUSE flags must be
1187# enabled. The --hidden option is really for internal use only as it
1188# means the USE flag we're checking is hidden expanded, so it won't be found
1189# in IUSE like normal USE flags.
1190#
1191# Remember that this function isn't terribly intelligent so order of optional
1192# flags matter.
1530built_with_use() { 1193built_with_use() {
1194 local hidden="no"
1195 if [[ $1 == "--hidden" ]] ; then
1196 hidden="yes"
1197 shift
1198 fi
1199
1200 local missing_action="die"
1201 if [[ $1 == "--missing" ]] ; then
1202 missing_action=$2
1203 shift ; shift
1204 case ${missing_action} in
1205 true|false|die) ;;
1206 *) die "unknown action '${missing_action}'";;
1207 esac
1208 fi
1209
1531 local opt=$1 1210 local opt=$1
1532 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1211 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1533 1212
1534 local PKG=$(best_version $1) 1213 local PKG=$(best_version $1)
1214 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1535 shift 1215 shift
1536 1216
1537 local USEFILE="${ROOT}/var/db/pkg/${PKG}/USE" 1217 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1538 [[ ! -e ${USEFILE} ]] && return 1 1218 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1219
1220 # if the IUSE file doesn't exist, the read will error out, we need to handle
1221 # this gracefully
1222 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1223 case ${missing_action} in
1224 true) return 0;;
1225 false) return 1;;
1226 die) die "Unable to determine what USE flags $PKG was built with";;
1227 esac
1228 fi
1229
1230 if [[ ${hidden} == "no" ]] ; then
1231 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1232 # Don't check USE_EXPAND #147237
1233 local expand
1234 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1235 if [[ $1 == ${expand}_* ]] ; then
1236 expand=""
1237 break
1238 fi
1239 done
1240 if [[ -n ${expand} ]] ; then
1241 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1242 case ${missing_action} in
1243 true) return 0;;
1244 false) return 1;;
1245 die) die "$PKG does not actually support the $1 USE flag!";;
1246 esac
1247 fi
1248 fi
1249 fi
1539 1250
1540 local USE_BUILT=$(<${USEFILE}) 1251 local USE_BUILT=$(<${USEFILE})
1541 while [[ $# -gt 0 ]] ; do 1252 while [[ $# -gt 0 ]] ; do
1542 if [[ ${opt} = "-o" ]] ; then 1253 if [[ ${opt} = "-o" ]] ; then
1543 has $1 ${USE_BUILT} && return 0 1254 has $1 ${USE_BUILT} && return 0
1547 shift 1258 shift
1548 done 1259 done
1549 [[ ${opt} = "-a" ]] 1260 [[ ${opt} = "-a" ]]
1550} 1261}
1551 1262
1263# @FUNCTION: epunt_cxx
1264# @USAGE: [dir to scan]
1265# @DESCRIPTION:
1552# Many configure scripts wrongly bail when a C++ compiler 1266# Many configure scripts wrongly bail when a C++ compiler could not be
1553# could not be detected. #73450 1267# detected. If dir is not specified, then it defaults to ${S}.
1268#
1269# http://bugs.gentoo.org/73450
1554epunt_cxx() { 1270epunt_cxx() {
1555 local dir=$1 1271 local dir=$1
1556 [[ -z ${dir} ]] && dir=${S} 1272 [[ -z ${dir} ]] && dir=${S}
1557 ebegin "Removing useless C++ checks" 1273 ebegin "Removing useless C++ checks"
1558 local f 1274 local f
1559 for f in $(find ${dir} -name configure) ; do 1275 find "${dir}" -name configure | while read f ; do
1560 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1276 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1561 done 1277 done
1562 eend 0 1278 eend 0
1563} 1279}
1564 1280
1565# dopamd <file> [more files] 1281# @FUNCTION: make_wrapper
1566# 1282# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1567# Install pam auth config file in /etc/pam.d 1283# @DESCRIPTION:
1568dopamd() { 1284# Create a shell wrapper script named wrapper in installpath
1569 [[ -z $1 ]] && die "dopamd requires at least one argument" 1285# (defaults to the bindir) to execute target (default of wrapper) by
1570 1286# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1571 use pam || return 0 1287# libpaths followed by optionally changing directory to chdir.
1572
1573 INSDESTTREE=/etc/pam.d \
1574 doins "$@" || die "failed to install $@"
1575}
1576# newpamd <old name> <new name>
1577#
1578# Install pam file <old name> as <new name> in /etc/pam.d
1579newpamd() {
1580 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1581
1582 use pam || return 0
1583
1584 INSDESTTREE=/etc/pam.d \
1585 newins "$1" "$2" || die "failed to install $1 as $2"
1586}
1587
1588# make a wrapper script ...
1589# NOTE: this was originally games_make_wrapper, but I noticed other places where
1590# this could be used, so I have moved it here and made it not games-specific
1591# -- wolf31o2
1592# $1 == wrapper name
1593# $2 == binary to run
1594# $3 == directory to chdir before running binary
1595# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1596# $5 == path for wrapper
1597make_wrapper() { 1288make_wrapper() {
1598 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1289 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1599 local tmpwrapper=$(emktemp) 1290 local tmpwrapper=$(emktemp)
1291 # We don't want to quote ${bin} so that people can pass complex
1292 # things as $bin ... "./someprog --args"
1600 cat << EOF > "${tmpwrapper}" 1293 cat << EOF > "${tmpwrapper}"
1601#!/bin/sh 1294#!/bin/sh
1602cd "${chdir}" 1295cd "${chdir:-.}"
1296if [ -n "${libdir}" ] ; then
1297 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1603export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}" 1298 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1299 else
1300 export LD_LIBRARY_PATH="${libdir}"
1301 fi
1302fi
1604exec ${bin} "\$@" 1303exec ${bin} "\$@"
1605EOF 1304EOF
1606 chmod go+rx "${tmpwrapper}" 1305 chmod go+rx "${tmpwrapper}"
1607 if [ -n "${5}" ] 1306 if [[ -n ${path} ]] ; then
1608 then 1307 (
1609 exeinto ${5} 1308 exeinto "${path}"
1610 newexe "${tmpwrapper}" "${wrapper}" 1309 newexe "${tmpwrapper}" "${wrapper}"
1310 ) || die
1611 else 1311 else
1612 newbin "${tmpwrapper}" "${wrapper}" 1312 newbin "${tmpwrapper}" "${wrapper}" || die
1313 fi
1314}
1315
1316# @FUNCTION: path_exists
1317# @USAGE: [-a|-o] <paths>
1318# @DESCRIPTION:
1319# Check if the specified paths exist. Works for all types of paths
1320# (files/dirs/etc...). The -a and -o flags control the requirements
1321# of the paths. They correspond to "and" and "or" logic. So the -a
1322# flag means all the paths must exist while the -o flag means at least
1323# one of the paths must exist. The default behavior is "and". If no
1324# paths are specified, then the return value is "false".
1325path_exists() {
1326 local opt=$1
1327 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1328
1329 # no paths -> return false
1330 # same behavior as: [[ -e "" ]]
1331 [[ $# -eq 0 ]] && return 1
1332
1333 local p r=0
1334 for p in "$@" ; do
1335 [[ -e ${p} ]]
1336 : $(( r += $? ))
1337 done
1338
1339 case ${opt} in
1340 -a) return $(( r != 0 )) ;;
1341 -o) return $(( r == $# )) ;;
1342 esac
1343}
1344
1345# @FUNCTION: in_iuse
1346# @USAGE: <flag>
1347# @DESCRIPTION:
1348# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1349# as necessary.
1350#
1351# Note that this function should not be used in the global scope.
1352in_iuse() {
1353 debug-print-function ${FUNCNAME} "${@}"
1354 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1355
1356 local flag=${1}
1357 local liuse=( ${IUSE} )
1358
1359 has "${flag}" "${liuse[@]#[+-]}"
1360}
1361
1362# @FUNCTION: use_if_iuse
1363# @USAGE: <flag>
1364# @DESCRIPTION:
1365# Return true if the given flag is in USE and IUSE.
1366#
1367# Note that this function should not be used in the global scope.
1368use_if_iuse() {
1369 in_iuse $1 || return 1
1370 use $1
1371}
1372
1373# @FUNCTION: usex
1374# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1375# @DESCRIPTION:
1376# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1377# otherwise echo [false output][false suffix] (defaults to "no").
1378usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1379
1380# @FUNCTION: prune_libtool_files
1381# @USAGE: [--all]
1382# @DESCRIPTION:
1383# Locate unnecessary libtool files (.la) and libtool static archives
1384# (.a) and remove them from installation image.
1385#
1386# By default, .la files are removed whenever the static linkage can
1387# either be performed using pkg-config or doesn't introduce additional
1388# flags.
1389#
1390# If '--all' argument is passed, all .la files are removed. This is
1391# usually useful when the package installs plugins and does not use .la
1392# files for loading them.
1393#
1394# The .a files are only removed whenever corresponding .la files state
1395# that they should not be linked to, i.e. whenever these files
1396# correspond to plugins.
1397#
1398# Note: if your package installs any .pc files, this function implicitly
1399# calls pkg-config. You should add it to your DEPEND in that case.
1400prune_libtool_files() {
1401 debug-print-function ${FUNCNAME} "$@"
1402
1403 local removing_all opt
1404 for opt; do
1405 case "${opt}" in
1406 --all)
1407 removing_all=1
1408 ;;
1409 *)
1410 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1411 esac
1412 done
1413
1414 # Create a list of all .pc-covered libs.
1415 local pc_libs=()
1416 if [[ ! ${removing_all} ]]; then
1417 local f
1418 local tf=${T}/prune-lt-files.pc
1419 local pkgconf=$(tc-getPKG_CONFIG)
1420
1421 while IFS= read -r -d '' f; do # for all .pc files
1422 local arg
1423
1424 sed -e '/^Requires:/d' "${f}" > "${tf}"
1425 for arg in $("${pkgconf}" --libs "${tf}"); do
1426 [[ ${arg} == -l* ]] && pc_libs+=( lib${arg#-l}.la )
1427 done
1428 done < <(find "${D}" -type f -name '*.pc' -print0)
1429
1430 rm -f "${tf}"
1431 fi
1432
1433 local f
1434 while IFS= read -r -d '' f; do # for all .la files
1435 local archivefile=${f/%.la/.a}
1436
1437 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1438
1439 # Remove static libs we're not supposed to link against.
1440 if grep -q '^shouldnotlink=yes$' "${f}"; then
1441 if [[ -f ${archivefile} ]]; then
1442 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1443 rm -f "${archivefile}"
1444 fi
1445
1446 # The .la file may be used by a module loader, so avoid removing it
1447 # unless explicitly requested.
1448 [[ ${removing_all} ]] || continue
1613 fi 1449 fi
1450
1451 # Remove .la files when:
1452 # - user explicitly wants us to remove all .la files,
1453 # - respective static archive doesn't exist,
1454 # - they are covered by a .pc file already,
1455 # - they don't provide any new information (no libs & no flags).
1456 local reason
1457 if [[ ${removing_all} ]]; then
1458 reason='requested'
1459 elif [[ ! -f ${archivefile} ]]; then
1460 reason='no static archive'
1461 elif has "${f##*/}" "${pc_libs[@]}"; then
1462 reason='covered by .pc'
1463 elif [[ ! $(sed -nre \
1464 "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1465 "${f}") ]]; then
1466 reason='no libs & flags'
1467 fi
1468
1469 if [[ ${reason} ]]; then
1470 einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1471 rm -f "${f}"
1472 fi
1473 done < <(find "${D}" -type f -name '*.la' -print0)
1614} 1474}
1475
1476check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1477
1478fi

Legend:
Removed from v.1.174  
changed lines
  Added in v.1.400

  ViewVC Help
Powered by ViewVC 1.1.20